Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/domain.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/domain.cpp	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/domain.cpp	(revision 1875)
@@ -2101,4 +2101,33 @@
   }
 
+  void CDomain::sendDomainToCouplerOut(CContextClient* client, const string& fieldId, int posInGrid)
+  {
+    if (sendDomainToFileServer_done_.count(client)!=0) return ;
+    else sendDomainToFileServer_done_.insert(client) ;
+    
+    const string domainId = "_domain["+std::to_string(posInGrid)+"]_of_"+fieldId ;
+    
+    if (!domain_ref.isEmpty())
+    {
+      auto domain_ref_tmp=domain_ref.getValue() ;
+      domain_ref.reset() ; // remove the reference, find an other way to do that more cleanly
+      this->sendAllAttributesToServer(client, domainId)  ;
+      domain_ref = domain_ref_tmp ;
+    }
+    else this->sendAllAttributesToServer(client, domainId)  ;
+
+    this->sendDistributionAttributes(client, domainId);   
+    this->sendIndex(client, domainId);       
+    this->sendLonLat(client, domainId);
+    this->sendArea(client, domainId);    
+    this->sendDataIndex(client, domainId);
+  }
+
+  void CDomain::makeAliasForCoupling(const string& fieldId, int posInGrid)
+  {
+    const string domainId = "_domain["+std::to_string(posInGrid)+"]_of_"+fieldId ;
+    this->createAlias(domainId) ;
+  }
+
   /*!
     Send all attributes from client to connected clients
@@ -2119,9 +2148,10 @@
     Send global index from client to connected client(s)
   */
-  void CDomain::sendIndex(CContextClient* client)
+  void CDomain::sendIndex(CContextClient* client, const string& domainId)
   TRY
   {
+    string serverDomainId = domainId.empty() ? this->getId() : domainId ;
+    
     int ns, n, i, j, ind, nv, idx;
-   
     int serverSize = client->serverSize;
     CEventClient eventIndex(getType(), EVENT_ID_INDEX);
@@ -2146,5 +2176,5 @@
 
       list_msgsIndex.push_back(CMessage());
-      list_msgsIndex.back() << this->getId() << (int)type; // enum ne fonctionne pour les message => ToFix
+      list_msgsIndex.back() << serverDomainId << (int)type; // enum ne fonctionne pour les message => ToFix
       list_msgsIndex.back() << isCurvilinear;
       list_msgsIndex.back() << list_indGlob.back(); //list_indi.back() << list_indj.back();
@@ -2161,7 +2191,9 @@
     it calculates this distribution then sends it to the corresponding clients on the next level
   */
-  void CDomain::sendDistributionAttributes(CContextClient* client)
+  void CDomain::sendDistributionAttributes(CContextClient* client, const string& domainId)
   TRY
   {
+    string serverDomainId = domainId.empty() ? this->getId() : domainId ;
+
     int nbServer = client->serverSize;
     std::vector<int> nGlobDomain(2);
@@ -2192,5 +2224,5 @@
         msgs.push_back(CMessage());
         CMessage& msg = msgs.back();
-        msg << this->getId() ;
+        msg << serverDomainId ;
         msg << isUnstructed_;
         msg << ni_srv << ibegin_srv << nj_srv << jbegin_srv;
@@ -2209,9 +2241,10 @@
     Send area from client to connected client(s)
   */
-  void CDomain::sendArea(CContextClient* client)
+  void CDomain::sendArea(CContextClient* client, const string& domainId)
   TRY
   {
     if (!hasArea) return;
-
+    string serverDomainId = domainId.empty() ? this->getId() : domainId ;
+    
     int ns, n, i, j, ind, nv, idx;
     int serverSize = client->serverSize;
@@ -2242,5 +2275,5 @@
 
       list_msgsArea.push_back(CMessage());
-      list_msgsArea.back() << this->getId() << hasArea;
+      list_msgsArea.back() <<serverDomainId << hasArea;
       list_msgsArea.back() << list_area.back();
       eventArea.push(rank, nbSenders[serverSize][rank], list_msgsArea.back());
@@ -2255,9 +2288,10 @@
     Because longitude and latitude are optional, this function only called if latitude and longitude exist
   */
-  void CDomain::sendLonLat(CContextClient* client)
+  void CDomain::sendLonLat(CContextClient* client, const string& domainId)
   TRY
   {
     if (!hasLonLat) return;
-
+    string serverDomainId = domainId.empty() ? this->getId() : domainId ;
+    
     int ns, n, i, j, ind, nv, idx;
     int serverSize = client->serverSize;
@@ -2316,5 +2350,5 @@
       list_msgsLat.push_back(CMessage());
 
-      list_msgsLon.back() << this->getId() << hasLonLat;
+      list_msgsLon.back() << serverDomainId << hasLonLat;
       if (hasLonLat) 
         list_msgsLon.back() << list_lon.back();
@@ -2325,5 +2359,5 @@
       }
 
-      list_msgsLat.back() << this->getId() << hasLonLat;
+      list_msgsLat.back() << serverDomainId << hasLonLat;
       if (hasLonLat)
         list_msgsLat.back() << list_lat.back();
@@ -2348,7 +2382,9 @@
     The compressed index are represented with 1 and others are represented with -1
   */
-  void CDomain::sendDataIndex(CContextClient* client)
+  void CDomain::sendDataIndex(CContextClient* client, const string& domainId)
   TRY
   {
+    string serverDomainId = domainId.empty() ? this->getId() : domainId ;
+    
     int ns, n, i, j, ind, nv, idx;
     int serverSize = client->serverSize;
@@ -2406,5 +2442,5 @@
 
       list_msgsDataIndex.push_back(CMessage());
-      list_msgsDataIndex.back() << this->getId();
+      list_msgsDataIndex.back() << serverDomainId ;
       list_msgsDataIndex.back() << list_data_i_index.back() << list_data_j_index.back();
       eventDataIndex.push(rank, nbSenders[serverSize][rank], list_msgsDataIndex.back());
@@ -2614,5 +2650,6 @@
            << "The number of sending clients is not correct."
            << "Expected number: " << recvClientRanks_.size() << " but received " << nbReceived);
-
+    
+    int nbLonInd = 0;
     vector<CArray<double,1> > recvLonValue(nbReceived);
     vector<CArray<double,2> > recvBoundsLonValue(nbReceived);    
@@ -2631,5 +2668,4 @@
     if (hasLonLat)
     {
-      int nbLonInd = 0;
       for (i = 0; i < nbReceived; ++i)
       {
@@ -2665,4 +2701,39 @@
         }
       }       
+    }
+
+   // setup attribute depending the type of domain
+    if (hasLonLat)
+    {
+      nbLonInd = globalLocalIndexMap_.size();
+      if (ni*nj != nbLonInd)
+        ERROR("void CDomain::recvLon(std::map<int, CBufferIn*>& rankBuffers)",
+             << "The number of index received is not coherent with the given resolution"
+             << "nbLonInd=" << nbLonInd << ", ni=" << ni <<", nj"<<ni<<" ni*nj="<<ni*nj);
+
+      if (type == type_attr::rectilinear || type == type_attr::curvilinear)
+      {
+        lonvalue_2d.resize(ni,nj);
+          for(int ij=0, j=0 ; j<nj ; j++)
+            for(int i=0 ; i<ni; i++, ij++) lonvalue_2d(i,j) = lonvalue(ij) ;
+        
+        if (hasBounds)
+        {
+          bounds_lon_2d.resize(nvertex, ni, nj) ;
+          for(int ij=0, j=0 ; j<nj ; j++)
+            for(int i=0 ; i<ni; i++, ij++) 
+              for(int nv=0; nv<nvertex; nv++) bounds_lon_2d(nv,i,j) = bounds_lonvalue(nv,ij) ;
+        }
+      }
+    }
+    else if (type == type_attr::unstructured || type == type_attr::gaussian)
+    {
+      lonvalue_1d.resize(nbLonInd);
+      lonvalue_1d = lonvalue ;
+      if (hasBounds)
+      {
+        bounds_lon_1d.resize(nvertex, nbLonInd) ;
+        bounds_lon_1d = bounds_lonvalue ;
+      }
     }
   }
@@ -2717,7 +2788,7 @@
     }
 
+    int nbLatInd = 0;
     if (hasLonLat)
     {
-      int nbLatInd = 0;
       for (i = 0; i < nbReceived; ++i)
       {
@@ -2756,4 +2827,44 @@
       }       
     }
+      // setup attribute depending the type of domain
+    if (hasLonLat)
+    {
+      nbLatInd = globalLocalIndexMap_.size();
+      
+      if (ni*nj != nbLatInd)
+        ERROR("void CDomain::recvLat(std::map<int, CBufferIn*>& rankBuffers)",
+             << "The number of index received is not coherent with the given resolution"
+            << "nbLonInd=" << nbLatInd << ", ni=" << ni <<", nj"<<ni<<" ni*nj="<<ni*nj);
+
+      if (type == type_attr::rectilinear || type == type_attr::curvilinear)
+      {
+        {
+          latvalue_2d.resize(ni,nj);
+          for(int ij=0, j=0 ; j<nj ; j++)
+            for(int i=0 ; i<ni; i++, ij++) latvalue_2d(i,j) = latvalue(ij) ;
+        
+          if (hasBounds)
+          {
+            bounds_lat_2d.resize(nvertex, ni, nj) ;
+            for(int ij=0, j=0 ; j<nj ; j++)
+              for(int i=0 ; i<ni; i++, ij++) 
+                for(int nv=0; nv<nvertex; nv++) bounds_lat_2d(nv,i,j) = bounds_latvalue(nv,ij) ;
+          }
+        }
+      }
+      else if (type == type_attr::unstructured || type == type_attr::gaussian)
+      {
+        if (hasLonLat)
+        {
+          latvalue_1d.resize(nbLatInd);
+          latvalue_1d = latvalue ;
+          if (hasBounds)
+          {
+            bounds_lat_1d.resize(nvertex, nbLatInd) ;
+            bounds_lon_1d = bounds_lonvalue ;
+          }
+        }
+      }
+    } 
   }
   CATCH_DUMP_ATTR
@@ -3016,40 +3127,5 @@
   }
   CATCH_DUMP_ATTR
-
-  /*!
-  \brief Check if a domain is completed
-  Before make any domain processing, we must be sure that all domain informations have
-  been sent, for exemple when reading a grid in a file or when grid elements are sent by an
-  other context (coupling). So all direct reference of the domain (domain_ref) must be also completed
-  \return true if domain and domain reference are completed
-  */
-  bool CDomain::checkIfCompleted(void)
-  {
-    if (hasDirectDomainReference()) if (!getDirectDomainReference()->checkIfCompleted()) return false;
-    return isCompleted_ ;
-  }
-
-  /*!
-  \brief Set a domain as completed
-   When all information about a domain have been received, the domain is tagged as completed and is
-   suitable for processing
-  */
-  void CDomain::setCompleted(void)
-  {
-    if (hasDirectDomainReference()) getDirectDomainReference()->setCompleted() ;
-    isCompleted_=true ;
-  }
-
-  /*!
-  \brief Set a domain as uncompleted
-   When informations about a domain are expected from a grid reading from file or coupling, the domain is 
-   tagged as uncompleted and is not suitable for processing
-  */
-  void CDomain::setUncompleted(void)
-  {
-    if (hasDirectDomainReference()) getDirectDomainReference()->setUncompleted() ;
-    isCompleted_=false ;
-  }
-  
+    
   /*!
    * Go through the hierarchy to find the domain from which the transformations must be inherited
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/domain.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/domain.hpp	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/domain.hpp	(revision 1875)
@@ -111,8 +111,24 @@
 
          static bool dispatchEvent(CEventServer& event);
-
-         bool checkIfCompleted(void) ;
-         void setCompleted(void) ;
-         void setUncompleted(void) ;
+      
+      private:
+         /** define if the domain is completed or not ie all attributes have been received before in case 
+             of grid reading from file or coupling */ 
+         bool isCompleted_=true ;  
+      public:     
+        /*!
+           \brief Check if a domain is completed
+           Before make any domain processing, we must be sure that all domain informations have
+           been sent, for exemple when reading a grid in a file or when grid elements are sent by an
+           other context (coupling). So all direct reference of the domain (domain_ref) must be also completed
+           \return true if domain and domain reference are completed
+          */
+         bool isCompleted(void)
+         {
+           if (hasDirectDomainReference()) if (!getDirectDomainReference()->isCompleted()) return false;
+           else return isCompleted_ ;
+         }
+         void setCompleted(void) { isCompleted_=true ; }
+         void unsetCompleted(void) { isCompleted_=false ; }
 
       public:
@@ -190,11 +206,20 @@
          std::set<CContextClient*> sendDomainToFileServer_done_ ;
        private:
-         
+         public:
+         void sendDomainToCouplerOut(CContextClient* client, const string& fieldId, int posInGrid) ;
+       private:
+         std::set<CContextClient*> sendDomainToCouplerOut_done_ ;
+      
+       public:
+        void makeAliasForCoupling(const string& fieldId, int posInGrid) ;
+
+       private:
+
          void sendAttributes(); // ym obsolete -> to be removed
-         void sendIndex(CContextClient* client);
-         void sendDistributionAttributes(CContextClient* client);
-         void sendArea(CContextClient* client);
-         void sendLonLat(CContextClient* client);         
-         void sendDataIndex(CContextClient* client);
+         void sendIndex(CContextClient* client, const string& domainId="");
+         void sendDistributionAttributes(CContextClient* client, const string& domainId="");
+         void sendArea(CContextClient* client, const string& domainId="");
+         void sendLonLat(CContextClient* client, const string& domainId="");         
+         void sendDataIndex(CContextClient* client, const string& domainId="");
          void convertLonLatValue();
          void fillInRectilinearLonLat();
@@ -228,8 +253,4 @@
          bool isClientChecked; // Verify whether all attributes of domain on the client side are good
          bool isClientAfterTransformationChecked;
-         
-         /** define if the domain is completed or not ie all attributes have been received before in case 
-             of grid reading from file or coupling */ 
-         bool isCompleted_=true ;  
 
 /** global index of the domain on server side, sent by the clients. This is global index for lon, lat, mask elements (ie non masked elements)
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/field.cpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/field.cpp	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/field.cpp	(revision 1875)
@@ -133,5 +133,9 @@
           return true;
           break;
-
+     
+        case EVENT_ID_GRID_COMPLETED :
+          recvGridCompleted(event);
+          return true;
+          break;
         default :
           ERROR("bool CField::dispatchEvent(CEventServer& event)", << "Unknown Event");
@@ -142,5 +146,5 @@
   CATCH
 
-  void CField::sendUpdateData(const CArray<double,1>& data, CContextClient* client)
+  void CField::sendUpdateData(Time timeStamp, const CArray<double,1>& data, CContextClient* client)
   TRY
   {
@@ -169,5 +173,5 @@
             for (int n = 0; n < data_tmp.numElements(); n++) data_tmp(n) = data(index(n));
 
-            list_msg.back() << getId() << data_tmp;
+            list_msg.back() << getId() << timeStamp << data_tmp;
             event.push(rank, 1, list_msg.back());
           }
@@ -189,5 +193,5 @@
         for (int n = 0; n < data_tmp.numElements(); n++) data_tmp(n) = data(index(n));
 
-        list_msg.back() << getId() << data_tmp;
+        list_msg.back() << getId() << timeStamp << data_tmp;
         event.push(rank, grid_->nbSenders_[receiverSize][rank], list_msg.back());
       }
@@ -219,9 +223,18 @@
   CATCH
 
+
   void  CField::recvUpdateData(std::map<int,CBufferIn*>& rankBuffers)
   TRY
   {
+    if (hasCouplerIn()) recvUpdateDataFromCoupler(rankBuffers) ;
+    else recvUpdateDataFromClient(rankBuffers) ;
+  }
+  CATCH
+
+  void  CField::recvUpdateDataFromClient(std::map<int,CBufferIn*>& rankBuffers)
+  TRY
+  {
     CContext* context = CContext::getCurrent();
-
+    Time timeStamp ;
     size_t sizeData = 0;
     if (0 == recvDataSrv.numElements())
@@ -249,5 +262,5 @@
         CArray<double,1> tmp;
         CArray<size_t,1>& indexTmp = it->second;
-        *(rankBuffers[it->first]) >> tmp;
+        *(rankBuffers[it->first]) >> timeStamp >> tmp;
         for (int idx = 0; idx < indexTmp.numElements(); ++idx) recv_data_tmp(indexTmp(idx)) = tmp(idx);
       }
@@ -552,4 +565,39 @@
   CATCH
 
+  
+  void CField::recvUpdateDataFromCoupler(std::map<int,CBufferIn*>& rankBuffers)
+  TRY
+  {
+    CContext* context = CContext::getCurrent();
+    Time timeStamp ;
+    if (wasDataAlreadyReceivedFromServer)
+    {  
+      lastDataReceivedFromServer = lastDataReceivedFromServer + freq_op;
+    }
+    else
+    {
+      // unlikely to input from file server where data are received at ts=0
+      // for coupling, it would be after the first freq_op, because for now we don't have
+      // restart mecanism to send the value at ts=0. It mus be changed in future
+      lastDataReceivedFromServer = context->getCalendar()->getInitDate()+freq_op;
+      wasDataAlreadyReceivedFromServer = true;
+    }
+
+    CArray<int,1>& storeClient = grid_->getStoreIndex_client();
+    CArray<double,1> recv_data_tmp(storeClient.numElements());  
+
+    auto& outLocalIndexStoreOnClient = grid_-> getOutLocalIndexStoreOnClient() ;
+    for (auto it = outLocalIndexStoreOnClient.begin(); it != outLocalIndexStoreOnClient.end(); ++it)
+    {
+      CArray<double,1> tmp;
+      CArray<size_t,1>& indexTmp = it->second;
+      *(rankBuffers[it->first]) >> timeStamp >> tmp;
+      for (int idx = 0; idx < indexTmp.numElements(); ++idx) recv_data_tmp(indexTmp(idx)) = tmp(idx);
+    }
+    
+    clientSourceFilter->streamData(lastDataReceivedFromServer, recv_data_tmp);
+    
+  }
+  CATCH_DUMP_ATTR
   /*!
     Receive read data from server
@@ -596,4 +644,42 @@
   }
   CATCH_DUMP_ATTR
+
+  void CField::checkForLateDataFromCoupler(void)
+  TRY
+  {
+    CContext* context = CContext::getCurrent();
+    const CDate& currentDate = context->getCalendar()->getCurrentDate();
+
+    CTimer timer("CField::checkForLateDataFromCoupler");
+    timer.resume();
+    traceOff() ;
+    timer.suspend();
+      
+    bool isDataLate;
+    do
+    {
+      const CDate nextDataDue = wasDataAlreadyReceivedFromServer ? (lastDataReceivedFromServer + freq_op) : context->getCalendar()->getInitDate();
+      isDataLate = (nextDataDue <= currentDate);
+
+      if (isDataLate)
+      {
+        timer.resume();
+//ym          context->checkBuffersAndListen();
+//ym            context->eventLoop();
+        context->globalEventLoop();
+
+        timer.suspend();
+      }
+    } while (isDataLate && timer.getCumulatedTime() < CXios::recvFieldTimeout);
+    
+    timer.resume();
+    traceOn() ;
+    timer.suspend() ;
+
+    if (isDataLate) ERROR("void CField::checkForLateDataFromCoupler(void)",
+                            << "Late data at timestep = " << currentDate);
+  }
+  CATCH_DUMP_ATTR
+
 
   void CField::checkForLateDataFromServer(void)
@@ -640,4 +726,21 @@
   }
   CATCH_DUMP_ATTR
+
+  void CField::triggerLateField(void)
+  TRY
+  {
+    if (hasFileIn()) 
+    {
+      checkForLateDataFromServer() ;
+      serverSourceFilter->trigger(CContext::getCurrent()->getCalendar()->getCurrentDate()) ;
+    } 
+    else if (hasCouplerIn())
+    {
+      checkForLateDataFromCoupler() ;
+      clientSourceFilter->trigger(CContext::getCurrent()->getCalendar()->getCurrentDate()) ;
+    }
+  }
+  CATCH_DUMP_ATTR
+
 
   void CField::checkIfMustAutoTrigger(void)
@@ -1140,4 +1243,5 @@
   {
     if (buildWorkflowGraphDone_) return true ;
+    
     const bool detectMissingValues = (!detect_missing_value.isEmpty() && !default_value.isEmpty() && detect_missing_value == true);
     const double defaultValue  = detectMissingValues ? default_value : (!default_value.isEmpty() ? default_value : 0.0);
@@ -1152,4 +1256,8 @@
     }
 
+    // now construct grid and check if element are enabled
+    solveGridReference() ; // grid_ is now defined
+    if (!isGridCompleted()) return false;
+
     // Check if we have an expression to parse
     std::shared_ptr<COutputPin> filterExpr ;
@@ -1161,7 +1269,4 @@
     }
     
-    // now construct grid and check if element are enabled
-    solveGridReference() ; // grid_ is now defined
-    
     // prepare transformation. Need to know before if workflow of auxillary field can be built
     if (hasDirectFieldReference())
@@ -1173,7 +1278,7 @@
       for(auto grid : gridPath)
       {
-        if (!grid->checkIfCompleted()) return false ;
         grid->solveElementsRefInheritance() ;
-        grid_->completeGrid(gridSrc); // grid generation, to be checked
+        grid->completeGrid(gridSrc); // grid generation, to be checked
+        grid->checkElementsAttributes() ;
         grid->prepareTransformGrid(gridSrc) ; // prepare the grid tranformation
         for(auto fieldId : grid->getAuxInputTransformGrid()) // try to build workflow graph for auxillary field tranformation
@@ -1205,6 +1310,4 @@
     else 
     {
-      if (!grid_->checkIfCompleted()) return false ;
-      
       if (hasFileIn()) // input file, attemp to read the grid from file
       {
@@ -1221,5 +1324,10 @@
          instantDataFilter=inputFilter ;
       }  
-      else 
+      else if (hasCouplerIn())
+      {
+        grid_->checkElementsAttributes() ;
+        instantDataFilter=inputFilter ;
+      }
+      else
       {
         setModelIn() ; // no reference, the field is potentially a source field from model
@@ -1256,4 +1364,11 @@
     // insert temporal filter before sending to files
     getTemporalDataFilter(gc, fileOut_->output_freq)->connectOutput(fileWriterFilter, 0);
+  } 
+
+  void CField::connectToCouplerOut(CGarbageCollector& gc)
+  {
+    // insert temporal filter before sending to files
+    fileWriterFilter = std::shared_ptr<CFileWriterFilter>(new CFileWriterFilter(gc, this, client));
+    instantDataFilter->connectOutput(fileWriterFilter, 0);
   } 
 
@@ -1303,4 +1418,24 @@
     serverSourceFilter -> connectOutput(inputFilter,0) ;
   } 
+
+  /*!
+   * Connect field to a source filter to receive data from coupler (on client side).
+   */
+   void CField::connectToCouplerIn(CGarbageCollector& gc)
+  {
+    CContext* context = CContext::getCurrent();
+
+    if (freq_op.isEmpty()) freq_op.setValue(TimeStep);
+    if (freq_offset.isEmpty()) freq_offset.setValue(freq_op.getValue() - TimeStep);
+
+    freq_operation_srv = freq_op ;
+    last_operation_srv = context->getCalendar()->getInitDate();
+    const CDuration toffset = freq_operation_srv - freq_offset.getValue() - context->getCalendar()->getTimeStep();
+    last_operation_srv     = last_operation_srv - toffset;
+
+    clientSourceFilter = std::shared_ptr<CSourceFilter>(new CSourceFilter(gc, grid_, false, false, freq_offset, true)) ;
+    clientSourceFilter -> connectOutput(inputFilter,0) ;
+  } 
+
 
   /*!
@@ -2021,12 +2156,9 @@
   CATCH_DUMP_ATTR
 
-  CContextClient* CField::getContextClient()
-  TRY
-  {
-    return client;
-  }
-  CATCH
-
-  
+  void CField::sendCloseDefinition(void)
+  {
+    CContext::getCurrent()->sendCloseDefinition(client) ;
+  }
+
   void CField::sendFieldToFileServer(void)
   {
@@ -2037,5 +2169,59 @@
     this->sendAddAllVariables(client);
   }
+
+  void CField::sendFieldToCouplerOut(void)
+  {
+    if (sendFieldToCouplerOut_done_) return ;
+    else sendFieldToCouplerOut_done_=true ;
+    grid_->sendGridToCouplerOut(client, this->getId());
+    this->sendGridCompleted();
+
+  }
   
+  void CField::makeGridAliasForCoupling(void) 
+  { 
+    grid_->makeAliasForCoupling(this->getId()); 
+  }
+
+ //! Client side: Send a message  announcing that the grid definition has been received from a coupling context
+   void CField::sendGridCompleted(void)
+   TRY
+   {
+      CEventClient event(getType(),EVENT_ID_GRID_COMPLETED);
+
+      if (client->isServerLeader())
+      {
+        CMessage msg;
+        msg<<this->getId();
+        for (auto& rank : client->getRanksServerLeader()) event.push(rank,1,msg);
+        client->sendEvent(event);
+      }
+      else client->sendEvent(event);
+   }
+   CATCH_DUMP_ATTR
+
+   //! Server side: Receive a message announcing that the grid definition has been received from a coupling context
+   void CField::recvGridCompleted(CEventServer& event)
+   TRY
+   {
+      CBufferIn* buffer=event.subEvents.begin()->buffer;
+      string id;
+      *buffer>>id ;
+      get(id)->recvGridCompleted(*buffer);
+   }
+   CATCH
+
+   //! Server side: Receive a message  message  announcing that the grid definition has been received from a coupling context
+   void CField::recvGridCompleted(CBufferIn& buffer)
+   TRY
+   {
+      setGridCompleted() ;
+   }
+   CATCH_DUMP_ATTR
+
+
+
+
+
   void CField::sendFieldToInputFileServer(void)
   {
@@ -2145,7 +2331,5 @@
   TRY
   {
-    bool isFieldRead  = getRelFile() && !getRelFile()->mode.isEmpty() && getRelFile()->mode == CFile::mode_attr::read;
-    bool isFieldWrite = getRelFile() && ( getRelFile()->mode.isEmpty() ||  getRelFile()->mode == CFile::mode_attr::write);
-    if (isFieldRead && !(operation.getValue() == "instant" || operation.getValue() == "once") )     
+    if (hasFileIn() && !(operation.getValue() == "instant" || operation.getValue() == "once") )     
       ERROR("void CField::checkTimeAttributes(void)",
          << "Unsupported operation for field '" << getFieldOutputName() << "'." << std::endl
@@ -2156,10 +2340,10 @@
       if (operation.getValue() == "instant")
       {
-        if (isFieldRead || isFieldWrite) freq_op.setValue(getRelFile()->output_freq.getValue());
+        if (hasFileIn() || hasFileOut()) freq_op.setValue(getRelFile()->output_freq.getValue());
         else freq_op=*freqOp ;
       }
       else freq_op.setValue(TimeStep);
     }
-    if (freq_offset.isEmpty()) freq_offset.setValue(isFieldRead ? NoneDu : (freq_op.getValue() - TimeStep));
+    if (freq_offset.isEmpty()) freq_offset.setValue(hasFileIn() ? NoneDu : (freq_op.getValue() - TimeStep));
   }
   CATCH_DUMP_ATTR
Index: /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/field.hpp
===================================================================
--- /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/field.hpp	(revision 1874)
+++ /XIOS/dev/dev_ym/XIOS_COUPLING/src/node/field.hpp	(revision 1875)
@@ -78,5 +78,5 @@
          {
            EVENT_ID_UPDATE_DATA, EVENT_ID_READ_DATA, EVENT_ID_READ_DATA_READY,
-           EVENT_ID_ADD_VARIABLE, EVENT_ID_ADD_VARIABLE_GROUP
+           EVENT_ID_ADD_VARIABLE, EVENT_ID_ADD_VARIABLE_GROUP, EVENT_ID_GRID_COMPLETED
          };
 
@@ -111,7 +111,6 @@
          std::map<int, StdSize> getGridDataBufferSize(CContextClient* client, bool bufferForWriting = false);
 
-         void setContextClient(CContextClient* newContextClient);
-         CContextClient* getContextClient();
-
+       public:
+          void makeGridAliasForCoupling(void) ;
        public:
          bool isActive(bool atCurrentTimestep = false) const;
@@ -144,4 +143,12 @@
 
          void sendFieldToFileServer(void) ;
+         void sendCloseDefinition(void) ;
+      
+      public:
+         void sendFieldToCouplerOut(void) ;
+      private:
+         bool sendFieldToCouplerOut_done_=false;
+      public:
+
          void sendFieldToInputFileServer(void) ;
 
@@ -177,7 +184,10 @@
         void sendAllAttributesToServer(CContextClient* client) ; 
         void sendUpdateData(const CArray<double,1>& data);
-        void sendUpdateData(const CArray<double,1>& data, CContextClient* client);
+        void sendUpdateData(Time timestamp, const CArray<double,1>& data, CContextClient* client);
         static void recvUpdateData(CEventServer& event);
         void recvUpdateData(std::map<int,CBufferIn*>& rankBuffers);
+        void recvUpdateDataFromClient(std::map<int,CBufferIn*>& rankBuffers);
+        void recvUpdateDataFromCoupler(std::map<int,CBufferIn*>& rankBuffers);
+        
         void writeField(void);
         bool sendReadDataRequest(const CDate& tsDataRequested, CContextClient* client);
@@ -188,7 +198,12 @@
         static void recvReadDataReady(CEventServer& event);
         void recvReadDataReady(vector<int> ranks, vector<CBufferIn*> buffers);
+        void recvDataFromCoupler(vector<int> ranks, vector<CBufferIn*> buffers) ;
         void checkForLateDataFromServer(void);
-        void checkIfMustAutoTrigger(void);
-        void autoTriggerIfNeeded(void);
+        void checkForLateDataFromCoupler(void) ;
+
+        void checkIfMustAutoTrigger(void); // ym obsolete
+        void autoTriggerIfNeeded(void); //ym obsolete
+        void triggerLateField(void) ;
+
         void outputField(CArray<double,3>& fieldOut);
         void outputField(CArray<double,2>& fieldOut);
@@ -227,4 +242,6 @@
 
         void connectToFileServer(CGarbageCollector& gc) ;
+        void connectToCouplerOut(CGarbageCollector& gc) ;
+        void connectToCouplerIn(CGarbageCollector& gc) ;
         void connectToModelInput(CGarbageCollector& gc) ;
         void connectToFileWriter(CGarbageCollector& gc) ;
@@ -241,4 +258,18 @@
                                                  map<CContextClient*,map<int,size_t>>& maxEventSize, 
                                                  bool bufferForWriting) ;
+      private:
+          bool isGridCompleted_ = true ;
+      public:
+          bool isGridCompleted() { return isGridCompleted_ ;} 
+          void setGridCompleted(void) { isGridCompleted_= true; }
+          void unsetGridCompleted(void) { isGridCompleted_ = false ;}
+      
+      public:     
+          void sendGridCompleted(void) ;
+      private:   
+          static void recvGridCompleted(CEventServer& event);
+          void recvGridCompleted(CBufferIn& buffer);
+
+
       private:
         std::vector<CGrid*> getGridPath(void) ;
@@ -315,4 +346,9 @@
       private:
          CContextClient* client;
+      public:
+         void setContextClient(CContextClient* newContextClient);
+         CContextClient* getContextClient(void) {return client;}
+
+      private:
 
          bool areAllReferenceSolved;
